program_name='HDanywhere_Modular_Demo'
(***********************************************************)
(***********************************************************)
(*  FILE_LAST_MODIFIED_ON: 04/05/2006  AT: 09:00:25        *)
(***********************************************************)
(* System Type : NetLinx                                   *)
(***********************************************************)
(* REV HISTORY:                                            *)
(***********************************************************)
(*
    $History: $
*)
(***********************************************************)
(*          DEVICE NUMBER DEFINITIONS GO BELOW             *)
(***********************************************************)
define_device

dvTP          	   = 10001:1:1

vdvModuleModular   = 33001:1:1


dvHDanywhere_Switch   = 0:80:0

(***********************************************************)
(*               CONSTANT DEFINITIONS GO BELOW             *)
(***********************************************************)
define_constant


CMD_OUTPUT_1                              = 1
CMD_OUTPUT_2                              = 2
CMD_OUTPUT_3                              = 3
CMD_OUTPUT_4                              = 4


CMD_INPUT_1                               = 21
CMD_INPUT_2                              = 22
CMD_INPUT_3                              = 23
CMD_INPUT_4                              = 24


CMD_SEND				 = 60 


(***********************************************************)
(*               VARIABLE DEFINITIONS GO BELOW             *)
(***********************************************************)
define_variable
		 
		 

constant integer OUTPUT_NUMBERS[] = 
{
  CMD_OUTPUT_1,   
  CMD_OUTPUT_2,   
  CMD_OUTPUT_3,   
  CMD_OUTPUT_4
};

constant integer INPUT_NUMBERS[] = 
{
  CMD_INPUT_1,   
  CMD_INPUT_2,   
  CMD_INPUT_3,   
  CMD_INPUT_4
};



char g_buffer[256];

char SWITCH_IP[15] = '172.16.106.10';  


define_module


define_module 'HDAnywhere_Modular'  HDAnywhere( vdvModuleModular, dvHDanywhere_Switch, SWITCH_IP );


(***********************************************************)
(*                THE EVENTS GO BELOW                      *)
(***********************************************************)
define_event

button_event[dvTP, OUTPUT_NUMBERS]
{
  push:
  {
    integer but;
  
    but = get_last( OUTPUT_NUMBERS );
    send_command dvTP, "'^BCF-',itoa( OUTPUT_NUMBERS[but] ),',1,#000748FF'";
    if (g_buffer != "")
      g_buffer = "g_buffer,',',itoa( but )";
    else 
      g_buffer = "itoa( but )";
  }
}

button_event[dvTP, INPUT_NUMBERS]
{
  push:
  {
    integer but;
    integer butTextFeedBack;
    integer count;
    char cJunk[3];
    
    but = get_last( INPUT_NUMBERS );
    send_command vdvModuleModular,"'SW ',g_buffer,'=',itoa( but ),';' ";
    
    count = 1; 
    while (count != 0)
    {
      count  = find_string ( g_buffer, ',', 1 );	
      cJunk = remove_string( g_buffer, ',', 1 );
      cJunk = left_string( cJunk, (length_string( cJunk ) - 1) );
      if (cjunk == "")
        cJunk = g_buffer;
      send_command dvTP, "'^TXT-',cJunk,',0,',itoa( but )";
      send_command dvTP, "'^BCF-',cJunk,',1,#0216CDFF'";
    }
    g_buffer = "";
  }
}


  
data_event[vdvModuleModular]
{
  string:
  {
    char cJunk[255], fbOutput[3], fbInput[3];
  
    if (find_string( data.text, 'SW ', 1 ) > 0)
    {
      while (find_string( data.text, 'SW ', 1 ) > 0)
      {
        cJunk = remove_string( data.text, 'SW ', 1 );
        cJunk = remove_string( data.text, ';', 1 );
        fbOutput = remove_string( cJunk, '=', 1 );
        fbOutput = left_string( fbOutput, (length_string( fbOutput ) - 1) );
        fbInput = cJunk;
        fbInput = left_string( fbInput, (length_string( fbInput ) - 1) );
		send_string 0, "'fbInput = ',fbInput";
		send_string 0, "'fbOutput = ',fbOutput";
        if (fbInput != "" || fbOutput != "")
	      send_command dvTP, "'^TXT-',fbOutput,',0,',fbInput";
      }
    }
	if (find_string( data.text, 'Version= ', 1 ))
	{
	  send_string 0, data.text;
	}
  }
}
(***********************************************************)
(*            THE ACTUAL PROGRAM GOES BELOW                *)
(***********************************************************)
define_program


